Q=2;
O=2;
eps=0.01;

%Generate HMM
prior0=normalise(rand(Q,1));
transmat0=mk_stochastic(rand(Q,Q));
obsmat0=mk_stochastic(rand(Q,O));

%Pick up numseq training sequences of length len
numseq=1;
len=1000;
data=sample_dhmm(prior0,transmat0,obsmat0,numseq,len);

%make a random initial guess of parameters
prior1=normalise(rand(Q,1));
transmat1=mk_stochastic(rand(Q,Q));
obsmat1=mk_stochastic(rand(Q,O));

%make a non-random initial guess of parameters
prior_est=(1-eps)prior0 + epsprior1;
transmat_est=(1-eps)transmat0 + epstransmat1;
obsmat_est=(1-eps)obsmat0 + epsobsmat1;

%Use Baum Welch algorithm to improve guess
max_iter=10;%max_iter = max. num EM steps to take (default 10)
thresh=10^(-5);%thresh = threshold for stopping EM (default 1e-4)
verbose=1;%verbose = 0 to suppress the display of the log lik at each iteration (Default 1).
[LL,prior2,transmat2,obsmat2]=learn_dhmm(data,prior_est,transmat_est,obsmat_est,...
                                            max_iter,thresh,verbose);

%comparing parameters and their estimates
prior_vectors=[prior0,prior_est,prior2]
trans_matrices=[transmat0,transmat_est,transmat2]
obs_matrices=[obsmat0,obsmat_est,obsmat2]
NoITER=length(LL)

%Plot a learning curve
plot(LL,'r')

%Compare likelihoods
%loglik1 = LL(NoITER);
%loglik2 = log_lik_dhmm(data, prior2, transmat2, obsmat2);
%loglik3 = log_lik_dhmm(data, prior0, transmat0, obsmat0);