function varargout = mendelHMM(varargin)
% MENDELHMM M-file for mendelHMM.fig
%      From the mendelHMM-toolbox by Steinar Thorvaldsen, Dept of Mathematics 
%      and Statistics, University of Troms, 9037 TROMS, - Norway.
%      http://www.math.uit.no/bi/hmm/
%      steinart@math.uit.no
%
%      MENDELHMM, by itself, creates a new MENDELHMM or raises the existing
%      singleton*.
%
%      H = MENDELHMM returns the handle to a new MENDELHMM or the handle to
%      the existing singleton*.
%
%      MENDELHMM('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MENDELHMM.M with the given input arguments.
%
%      MENDELHMM('Property','Value',...) creates a new MENDELHMM or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before mendelHMM_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to mendelHMM_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help mendelHMM

% Last Modified by GUIDE v2.5 06-Jan-2004 11:54:25

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @mendelHMM_OpeningFcn, ...
                   'gui_OutputFcn',  @mendelHMM_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before mendelHMM is made visible.
function mendelHMM_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to mendelHMM (see VARARGIN)

% Choose default command line output for mendelHMM
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes mendelHMM wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = mendelHMM_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushparametersview.
function pushparametersview_Callback(hObject, eventdata, handles)
% hObject    handle to pushparametersview (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global prior2 transmat2 obsmat2
% Must converge parameters to strings:
strtrans=num2str(transmat2, '%7.3f')
strobs=num2str(obsmat2, '%7.3f')

% Estimated parameters are shown on a new figure where text objects are
% created:
figure('Name',['mendelHMM EM-estimated model: ']), clf 
handl_transmattxt = uicontrol('Style', 'text', 'String', 'Transition matrix P = ',...
    'Position', [20 400 150 30] );
handl_transmatview = uicontrol('Style', 'text', 'String', strtrans,...
     'Position', [250 250 350 200]);
handl_obsmattxt = uicontrol('Style', 'text', 'String', 'Obs. matrix E = ',...
    'Position', [20 100 150 30] );
handl_obsmatview = uicontrol('Style', 'text', 'String', strobs,...
    'Position', [250 10 350 200] );


% --- Executes on button press in pushestimate.
function pushestimate_Callback(hObject, eventdata, handles)
% hObject    handle to pushestimate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global prior1 transmat1 obsmat1 dataE LL prior2 transmat2 obsmat2

% extracting selected initialization metod:
method=get(handles.popinitializationNum,'Value'); 
% extracting best loglik TEXT from GUI:
startLL=get(handles.textinitialbestlikelihoodNum,'String');

maxround=5; %-----may be changed here!!!!!!----
round=1; % when initialization method is random (=2), we want many guessrounds:
while (round == 1) | ((method == 2) & (round <=maxround))
    % First part of test is to assure that initialization is ready (transmat1-variables):
    if (round ==1 & str2num(startLL) == -Inf) | round >=2
        round
        runinitialization(method, handles);
    end
    [LL, priorEM, transmatEM, obsmatEM] = gen_HMM_em(dataE, prior1, transmat1, obsmat1, handles, 'max_iter', 15);
    % use model to compute log likelihood
    loglik = HMM_logprob(dataE, priorEM, transmatEM, obsmatEM)
    % log lik is slightly different than LL(end), since it is computed after the final M step
    set(handles.textlikelihoodNum,'string',loglik) % updated likelihood presented at GUI
    best_llstr=get(handles.textbestlikelihoodNum,'String'); % extracting best loglik TEXT from GUI
    if loglik > str2num(best_llstr)
        set(handles.textbestlikelihoodNum,'string',loglik) % updated best score at GUI
        % update parameters for best score:
        prior2=priorEM;
        transmat2=transmatEM;
        obsmat2=obsmatEM;
    end
    round=round+1;
end %while

% LL
transmatEM
obsmatEM

% --- Executes on button press in pushshample.
function pushshample_Callback(hObject, eventdata, handles)
% hObject    handle to pushshample (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% We want to produce new set of training data:
global prior transmat obsmat hidX dataE

set(handles.popusedataNum,'Value',1) %present 'No' instead of MendelData at GUI
updateGUI(handles); % The GUI and the basic matrices in the HMM is uppdated
numbex=str2num(get(handles.editnumNum,'String')) %first extracting number of experiments
T=str2num(get(handles.editlengthNum,'String')) %then extracting length of each sequence
[hidX,dataE] = sample_HMM(prior, transmat, obsmat, T, numbex)


% --- Executes on button press in pushlikelihoodview.
function pushlikelihoodview_Callback(hObject, eventdata, handles)
% hObject    handle to pushlikelihoodview (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global LL
figure('Name',['mendelHMM: likelihood in EM training ']), clf 
plot(LL,'*');
xlabel('iteration')
ylabel('loglikelihood')
title('EM training of HMM');


% --- Executes on button press in pushviewdata.
function pushviewdata_Callback(hObject, eventdata, handles)
% hObject    handle to pushviewdata (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

view_dataseq %display graphical view of sequences


% --- Executes on button press in pushmendeldataview.
function pushmendeldataview_Callback(hObject, eventdata, handles)
% hObject    handle to pushmendeldataview (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

experiment=get(handles.popusedataNum,'Value'); %extracting selected value from object

switch experiment
    case 1 % Value used when "No" is select, e.g. model sampled dataset
        view_sampleddata;
        % helpdlg('Select Mendel data first','Dataset Selection');
    otherwise
        view_mendeldata(experiment-1); %display graphical view of mendel exp. 1..8
end %switch


% --- Executes on mouse press over figure background.
function figure1_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object creation, after setting all properties.
function popgenesNum_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popgenesNum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

% --- Executes on selection change in popgenesNum.
function popgenesNum_Callback(hObject, eventdata, handles)
% hObject    handle to popgenesNum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popgenesNum contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popgenesNum

updateGUI(handles); % The GUI and the basic matrices in the HMM is uppdated
set(handles.popusedataNum,'Value',1) %present 'No' instead of MendelData at GUI


% --- Executes during object creation, after setting all properties.
function popploidyNum_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popploidyNum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in popploidyNum.
function popploidyNum_Callback(hObject, eventdata, handles)
% hObject    handle to popploidyNum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

updateGUI(handles); % The GUI and the basic matrices in the HMM is uppdated

% --------------------------------------------------------------------
function textpenotypesNum_Callback(hObject, eventdata, handles)
% hObject    handle to textpenotypesNum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object creation, after setting all properties.
function popusedataNum_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popusedataNum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in popusedataNum.
function popusedataNum_Callback(hObject, eventdata, handles)
% hObject    handle to popusedataNum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popusedataNum contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popusedataNum

global dataE;

experiment=get(hObject,'Value'); %extracting selected value from object
if experiment >= 2 & experiment <= 10
    % clear dataE, hidX; % prepare to read a new data set
    dataE=resample_mendeldata(experiment-1) % No experiment has Value number 1
    [n,m]= size(dataE);
    set(handles.editnumNum,'string',n); % new samplenumber presented at GUI
    set(handles.editlengthNum,'string',m); % new sample length presented at GUI
    switch experiment
        case 9 %This case is experiment 8 with 2 genes
            set(handles.popgenesNum,'Value',2); % new gene value presented at GUI
            updateGUI(handles); % The GUI and the basic matrices in the HMM is uppdated
        case 10 %This case is experiment 9 with 3 genes
            set(handles.popgenesNum,'Value',3); % new gene value presented at GUI
            updateGUI(handles); % The GUI and the basic matrices in the HMM is uppdated
        otherwise %This case is experiment 1-7 (1 gene)
            set(handles.popgenesNum,'Value',1); % new gene value presented at GUI
            updateGUI(handles); % The GUI and the basic matrices in the HMM is uppdated
    end %switch
end %if

% --- Executes during object creation, after setting all properties.
function editnumNum_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editnumNum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function editnumNum_Callback(hObject, eventdata, handles)
% hObject    handle to editnumNum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editnumNum as text
%        str2double(get(hObject,'String')) returns contents of editnumNum as a double
updateGUI(handles); % The GUI and the basic matrices in the HMM is uppdated
set(handles.popusedataNum,'Value',1) %present 'No' instead of MendelData at GUI


% --- Executes during object creation, after setting all properties.
function editlengthNum_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editlengthNum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


function editlengthNum_Callback(hObject, eventdata, handles)
% hObject    handle to editlengthNum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editlengthNum as text
%        str2double(get(hObject,'String')) returns contents of editlengthNum as a double

updateGUI(handles); % The GUI and the basic matrices in the HMM is uppdated
set(handles.popusedataNum,'Value',1) %present 'No' instead of MendelData at GUI


% --- Executes during object creation, after setting all properties.
function popinitializationNum_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popinitializationNum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in popinitializationNum.
function popinitializationNum_Callback(hObject, eventdata, handles)
% hObject    handle to popinitializationNum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popinitializationNum contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popinitializationNum

method=get(hObject,'Value'); %extracting selected value from object
runinitialization(method, handles);


% --------------------------------
function runinitialization(method, handles)
% User defined function to initialize the parameters.

E=str2num(get(handles.textpenotypesNum,'String')); % extracting number of observables
X=str2num(get(handles.textstatesNum,'String')); % extracting number of states
% genesNo=get(handles.popgenesNum,'Value'); %first extracting number of genes
% initbest_ll=str2num(get(handles.textbestlikelihoodNum,'String')); % extracting best loglik

% Now we can initialize our model:
switch method
    case 1 % dominant diagonal method
        dominance=0.67 % ------ may be changed here!!!!
        loglik_init = init_diagonal (X, E, dominance)        
    case 2 % random parameter method
        loglik_init = init_random (X, E)
end %switch
set(handles.textinitialbestlikelihoodNum,'string',loglik_init) % update initial likelihood presented at GUI

% ---------------------------------
function updateGUI(handles)
% User defined function executed when a new dataset is selected for use.
% The number of phenotypes and states is derived from the selections and
% uppdated on the GUI. The basic matrices in the HMM is also adjusted.

genes=get(handles.popgenesNum,'Value'); %extracting number of genes
val=get(handles.popploidyNum,'Value'); %extracting ploidy selected value from object
% (for one gene the real ploidy level, p, will be p=2*val)
% The number of genotypes will be p + 1. (combinatorics: choosing p out of 2 
% with replacement and disregarding order)
% The total number of states = number of genotypes ^ number of genes:
% states=(2*val +1)^genes
% We then uppdate the number of states and of phenotypes:
set(handles.textstatesNum,'string',(2*val+1)^genes) % updated states presented at GUI
set(handles.textpenotypesNum,'string',2^genes) % updated phenotypes presented at GUI

% We adjust the previous likelihoods:
set(handles.textinitialbestlikelihoodNum,'string',-Inf) % updated likelihood presented at GUI
set(handles.textlikelihoodNum,'string',-Inf) % updated at GUI
set(handles.textbestlikelihoodNum,'string',-Inf) % update at GUI

% We must also adjust the basic matrices in the HMM model:
switch val
    case 1
        set_diploidmode
    case 2
        set_tetraploidmode
end %switch

