function randI = sample_discr(pr_density, row, col)
% A quite general and useful function much like the built in random generator "rand", 
% but modyfied to produce the Index 1, 2, 3,  ...., n assosiated 
% with the given discrete probability density vector stored in pr_density.
% From the mendelHMM-toolbox by Steinar Thorvaldsen,
% http://www.math.uit.no/bi/hmm/

% randI = sample_discr(pr_density, row, col)

% Example
% sample_discr([0.2 0.6 0.2], 10, 3) produces 10 row vector of 
% 3 random integers from the set {1,2,3}, where the prob of being 1 is 0.2, 
% the prob of being 2 is 0.6 and the prob of beeing 3 is 0.2

n = length(pr_density);

if nargin == 1
  row = 1; col = 1;
elseif nargin == 2
  col == row;
end

r = rand(row, col);
randI = ones(row, col);
% The function cumsum creates a matrix with cumulated sum over the rows:
cumprob = cumsum(pr_density(:));

for i = 1:n-1
% randI increased by 1 each time r > cumprob(i):
  randI = randI + (r > cumprob(i));
end
 