% Sets the HMM in tetraploid(4x) mode, and defines the basic matrices according
% to the number of independent genes.

% From the mendelHMM-toolbox by Steinar Thorvaldsen, 2004.
% http://www.math.uit.no/bi/hmm/

global prior transmat obsmat
% The "true" matrices for 1 gene are first set up:
one36 = 1/36;
two9 = 2/9;
transmat = [1 0 0 0 0; 0.25 0.5 0.25 0 0; one36 two9 0.5 two9 one36; 0 0 0.25 0.5 0.25; 0 0 0 0 1];
obsmat = [1 0; 1 0; 1 0; 1 0; 0 1];
prior = [0 0 1 0 0]; %The startup case (tetraploid, heterozygote plants)

% loglik_best = -inf;

% If the model have 2 or 3 genes, the matrices can be constructed
% iteratively from the 1 gene case.
% The process of joining small matrices to make bigger ones is done by
% so called concatenation. 

genesNo=get(handles.popgenesNum,'Value') % extracting number of genes
if genesNo > 1
    for gene= 2:genesNo
        nullmat=zeros(size(transmat));
        nullmatObs=zeros(size(obsmat));
        nullvect= zeros(1, length(prior));
        transmat = [transmat  nullmat nullmat nullmat nullmat; transmat*0.25 transmat*0.5 transmat*0.25 nullmat nullmat; transmat*one36 transmat*two9 transmat*0.5 transmat*two9 transmat*one36; nullmat nullmat transmat*0.25 transmat*0.5 transmat*0.25; nullmat nullmat nullmat nullmat transmat];
        obsmat = [obsmat nullmatObs; obsmat nullmatObs; obsmat nullmatObs; obsmat nullmatObs; nullmatObs obsmat];
        prior = [nullvect nullvect prior nullvect nullvect]; 
    end
end