clear all
Q=[2,2];
O=[2,2];
N=length(Q);
NUM=200;
BIN=zeros(1,NUM);
eps=0.01;
w1=3/4;
w2=1-w1;

%Generate N HMModels
for i=1:N
count=i
prior0{i}=normalise(rand(Q(i),1));
transmat0{i}=mk_stochastic(rand(Q(i),Q(i)));
obsmat0{i}=mk_stochastic(rand(Q(i),O(i)));

numseq=1;
len=1000;
data=sample_dhmm(prior0{i},transmat0{i},obsmat0{i},numseq,len);

prior1=normalise(rand(Q(i),1));
transmat1=mk_stochastic(rand(Q(i),Q(i)));
obsmat1=mk_stochastic(rand(Q(i),O(i)));

prior_est=(1-eps)*prior0{i} + eps*prior1;
transmat_est=(1-eps)*transmat0{i} + eps*transmat1;
obsmat_est=(1-eps)*obsmat0{i} + eps*obsmat1;

max_iter=300;%max_iter = max. num EM steps to take (default 10)
thresh=10^(-4);%thresh = threshold for stopping EM (default 1e-4)
verbose=0;%verbose = 0 to suppress the display of the log lik at each iteration (Default 1).
[LL{i},prior2{i},transmat2{i},obsmat2{i}]=learn_dhmm(data,prior_est,transmat_est,obsmat_est,...
                                                           max_iter,thresh,verbose);
NoITER(i)=length(LL{i});
end

NoITER

pp=w1*prior0{1} + w2*prior0{2};
tt=w1*transmat0{1} + w2*transmat0{2};
oo=w1*obsmat0{1} + w2*obsmat0{2};

for k=1:NUM
    k
%Take a sequence to classify
data=sample_dhmm(pp,tt,oo,numseq,len);

%Compute the likelihood of given sequence for each class
for i=1:N
    LOGlik(i) = log_lik_dhmm(data, prior2{i}, transmat2{i}, obsmat2{i});
end

%Take a class with the biggest likelihood
[MM,I]=max(LOGlik);

if (I==1)
    BIN(k)=1;
end

end

PROBMIST=1-(sum(BIN))/NUM