function  [loglik_grid] = init_grid (X, E, genesNo)
% a grid-based test to find initial paramteter values
% NB: This is only a test version
% From the mendelHMM-toolbox by Steinar Thorvaldsen,
% http://www.math.uit.no/bi/hmm/

global dataE prior transmat obsmat prior1 transmat1 obsmat1 

loglik_grid = -inf;
prior0 = prior %The Mendel startup state (heterozygote plants)

% We use a grid with a peaked distribution of the stochastic vector.
% Ex: For one gene:
% Diploid case grid distributed vector: (2/3 1/6 1/6)
% Tetraploid case: (2/3 1/12 1/12 1/12 1/12)
% We test all the permutations of this peaked grid.

% First we have to generate the elements in the stochastic vector:
%prior0 = normalise(ones(X,1));
r= 1/9;
r2= 2*r;
r3= 3*r;
r6= 6*r;
r4= 1/6;
k=1/4;
k2=2*k;
% The "basic" matrices for 1 gene:
transmat0 = [r6 r4 r4; r4 r6 r4; r4 r4 r6];
obsmat0 = [r6 r3; r6 r3; r3 r6];

% If the model have 2 or 3 genes, the matrices can be constructed
% iteratively from the 1 gene case.
% The process of joining small matrices to make bigger ones is done by
% so called concatenation. 

if genesNo > 1
    for gene= 2:genesNo       
        nullmat=zeros(size(transmat0));
        nullmatObs=zeros(size(obsmat0));
        nullvect= zeros(1, length(prior0));
        transmat0 = [transmat0  nullmat nullmat; transmat0*0.25 transmat0*0.5 transmat0*0.25; nullmat nullmat transmat0];
        obsmat0 = [obsmat0 nullmatObs; obsmat0 nullmatObs; nullmatObs obsmat0];
        prior0 = [nullvect prior0 nullvect]; 
    end
end

loglik_grid = HMM_logprob(dataE, prior0, transmat0, obsmat0);

%New initialization ready:
prior1 = prior0
transmat1 = transmat0
obsmat1 = obsmat0