function states = sample_MC(prior, transP, T, numbex)
% Produces random state sequences from a Markov model with transition probability
% matrix transP.
% The prior is used to generate the first state and is in that way included in the sequence.
% From the mendelHMM-toolbox by Steinar Thorvaldsen, 2004.
% http://www.math.uit.no/bi/hmm/

% S = sample_MC(prior, transP, T) produces a sequence of length T.
% S = sample_MC(prior, transP, T, N) produces N rows each of length T.

if nargin==3
  numbex = 1;
end

states = zeros(numbex,T);
for i=1:numbex
  states(i, 1) = sample_discr(prior);
  for j=2:T
    states(i, j) = sample_discr(transP(states(i,j-1),:));
  end
end
