function view_dataseq
% view_dataseq  is an auxiary function for mendelHMM to plot a graphical
% view of the training data, and evt. the true hidden sequence and
% the predicted Veterbi path 
% From the mendelHMM-toolbox by Steinar Thorvaldsen, 2004.
% http://www.math.uit.no/bi/hmm/

global prior transmat obsmat hidX dataE

T=size(dataE,2); % length of the sequenses
[NoStates NoObs]= size(obsmat); %extracting number of states and observables

% reading from keybord the sequence to display:
prompt={...
         	'Which sequence number?',...
     	 };
def_answere={'1'};
answer=inputdlg(prompt,'View sequences',1,def_answere);

% Plotting may start:
if ~isempty(answer)
   max_i=size(dataE,1);
   index=str2num(answer{1});
	if ~isempty(index)
      if index <=max_i
         figure('Name',['mendelHMM Sequence: ' num2str(index)]) ;
         subplot(3,1,1);
         hold on;
         plot(dataE(index,:),'*');
         axis([0  T  1  NoObs])
         title('Sequence of observation:');
         hold off;
         
         subplot(3,1,2);
         hold on;
         plot(hidX(index,:),'*');
         axis([0  T  1  NoStates])
         title('Sequence of hiden states:');
         hold off;
         
         % Necessary to decode the Viterbi sequence:
         obslik = multinomial_prob(dataE(index,:), obsmat);
         % Run the Viterbi algorithm to decode the state sequence from observations:
         decodedPath = viterbi_path(prior, transmat, obslik)
         subplot(3,1,3);
         hold on;
         plot(decodedPath,'*');
         axis([0  T  1  NoStates])
         title('Viterbi decoded sequence:');
         hold off;
         Zoom on;
      end
   end
end
