function view_sampleddata
% A function for the program mendelHMM to visualize in 3-D the data 
% sampled from the HMM

% From the mendelHMM-toolbox by Steinar Thorvaldsen, 2004.
% http://www.math.uit.no/bi/hmm/

% Input (only global variables):
global obsmat hidX dataE

[N,T]=size(dataE); % Number N of sequences and length T of the sequenses
[NoStates NoObs]= size(obsmat); %extracting number of states and observables

% First we counts the occurence of each phenotype and each genotype:
countE=zeros(T,NoObs);
countX=zeros(T,NoStates);
for generation=1:T
    for sequence=1:N
        countE(generation, dataE(sequence,generation))= countE(generation, dataE(sequence,generation)) + 1;
        countX(generation, hidX(sequence,generation))= countX(generation, hidX(sequence,generation)) + 1;
    end;
end;
% Convert to frequency before plotting:
countE=countE/N;
countX=countX/N;
figure('Name',['mendelHMM: View of dataset sampled from HMM ']), clf 
subplot(1,2,1)
bar3(countE, 0.4, 'detached')
title ('Phenotype frequency sampled from HMM')
xlabel ('Phenotype');
ylabel ('Generation');
view([45 30])
subplot(1,2,2)
bar3(countX, 0.4, 'detached')
title ('Genotype frequency sampled from HMM')
xlabel ('Genotype');
ylabel ('Generation');
view([45 30])